<template>
  <div class="fr-container fr-p-5w">
    <TheHeader title="Statistiques" />
    <div class="fr-grid-row fr-grid-row--gutters">
      <div class="fr-col-12">
        <main class="main-container fr-tabs">
          <ul
            class="fr-tabs__list"
            role="tablist"
            aria-label="Statistiques"
          >
            <li role="presentation">
              <button
                id="beneficiaries-tab"
                class="fr-tabs__tab"
                tabindex="0"
                role="tab"
                aria-selected="true"
                aria-controls="beneficiaries-panel"
              >
                Bénéficiaires
              </button>
            </li>
            <li role="presentation">
              <button
                id="history-tab"
                class="fr-tabs__tab"
                tabindex="0"
                role="tab"
                aria-selected="false"
                aria-controls="history-panel"
              >
                Accompagnements
              </button>
            </li>
          </ul>

          <div
            id="beneficiaries-panel"
            class="fr-tabs__panel fr-tabs__panel--selected fr-px-0"
            role="tabpanel"
            aria-labelledby="beneficiaries-tab"
            tabindex="0"
          >
            <AtomAlert
              v-if="fetchError"
              :alert-type="AlertType.Error"
              :message="fetchError"
            />
            <StatsBeneficiaries
              :follow-up-type-options="followUpTypeOptions"
              :beneficiaries-cities-options="beneficiariesCitiesOptions"
              :agent-options="agentOptions"
            />
          </div>
          <div
            id="history-panel"
            class="fr-tabs__panel fr-tabs__panel--selected fr-px-0"
            role="tabpanel"
            aria-labelledby="history-tab"
            tabindex="0"
          >
            <AtomAlert
              v-if="fetchError"
              :alert-type="AlertType.Error"
              :message="fetchError"
            />
            <StatsHistory
              :follow-up-type-options="followUpTypeOptions"
              :beneficiaries-cities-options="beneficiariesCitiesOptions"
              :agent-options="agentOptions"
            />
          </div>
        </main>
      </div>
    </div>
  </div>
</template>

<script setup>
  import { toOptions, agentToAgentOption, withEmptyValue } from '~/utils'
  import { AlertType } from '~/utils/constants/alert'
  import { getRandomId } from '~/utils/random'

  definePageMeta({ middleware: 'can-access-stats' })

  const {
    $loadOrganisationFollowUpTypes,
    $loadBeneficiariesCities,
    $loadAgents
  } = useNuxtApp()

  const { data: followUpTypeOptions, error: followUpTypeOptionsError } =
    useLazyAsyncData('followUpTypeOptions', loadFollowUpTypeOptions, {
      server: false
    })

  const {
    data: beneficiariesCitiesOptions,
    error: beneficiariesCitiesOptionsError
  } = useLazyAsyncData(
    getRandomId('beneficiariesCitiesOptions'),
    loadBeneficiariesCitiesOptions,
    { server: false }
  )

  const { data: agentOptions, error: agentOptionsError } = useLazyAsyncData(
    getRandomId('agentOptions'),
    loadAgentOptions,
    { server: false }
  )

  const fetchError = computed(() => {
    if (followUpTypeOptionsError.value) {
      return "La liste des types d'accompagnement n'a pas pu être chargée."
    }
    if (beneficiariesCitiesOptionsError.value) {
      return "La liste des villes n'a pas pu être chargée."
    }
    if (agentOptionsError.value) {
      return "La liste des référents n'a pas pu être chargée."
    }
    return ''
  })

  async function loadFollowUpTypeOptions() {
    const followUpTypes = await $loadOrganisationFollowUpTypes()
    return toOptions(followUpTypes, 'id', 'name')
  }

  async function loadBeneficiariesCitiesOptions() {
    const beneficiariesCities = await $loadBeneficiariesCities()
    return toOptions(beneficiariesCities, 'city', 'city')
  }

  async function loadAgentOptions() {
    const agents = await $loadAgents()
    return withEmptyValue(new Map(agents.map(agentToAgentOption)))
  }
</script>

<style scoped>
  ::v-deep .main-container {
    min-height: 100%;
  }
</style>
